// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package gen

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion7

// DoctorServiceClient is the client API for DoctorService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type DoctorServiceClient interface {
	// returns a list of doctors
	ListDoctors(ctx context.Context, in *NilMsg, opts ...grpc.CallOption) (*DoctorList, error)
	// returns a list of doctors as a stream
	ListDoctorsStream(ctx context.Context, in *NilMsg, opts ...grpc.CallOption) (DoctorService_ListDoctorsStreamClient, error)
	// creates a new doctor
	AddDoctor(ctx context.Context, in *Doctor, opts ...grpc.CallOption) (*Doctor, error)
	// Check to see if the service is alive
	Alive(ctx context.Context, in *NilMsg, opts ...grpc.CallOption) (*NilMsg, error)
}

type doctorServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewDoctorServiceClient(cc grpc.ClientConnInterface) DoctorServiceClient {
	return &doctorServiceClient{cc}
}

func (c *doctorServiceClient) ListDoctors(ctx context.Context, in *NilMsg, opts ...grpc.CallOption) (*DoctorList, error) {
	out := new(DoctorList)
	err := c.cc.Invoke(ctx, "/proto.DoctorService/ListDoctors", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *doctorServiceClient) ListDoctorsStream(ctx context.Context, in *NilMsg, opts ...grpc.CallOption) (DoctorService_ListDoctorsStreamClient, error) {
	stream, err := c.cc.NewStream(ctx, &_DoctorService_serviceDesc.Streams[0], "/proto.DoctorService/ListDoctorsStream", opts...)
	if err != nil {
		return nil, err
	}
	x := &doctorServiceListDoctorsStreamClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type DoctorService_ListDoctorsStreamClient interface {
	Recv() (*Doctor, error)
	grpc.ClientStream
}

type doctorServiceListDoctorsStreamClient struct {
	grpc.ClientStream
}

func (x *doctorServiceListDoctorsStreamClient) Recv() (*Doctor, error) {
	m := new(Doctor)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *doctorServiceClient) AddDoctor(ctx context.Context, in *Doctor, opts ...grpc.CallOption) (*Doctor, error) {
	out := new(Doctor)
	err := c.cc.Invoke(ctx, "/proto.DoctorService/AddDoctor", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *doctorServiceClient) Alive(ctx context.Context, in *NilMsg, opts ...grpc.CallOption) (*NilMsg, error) {
	out := new(NilMsg)
	err := c.cc.Invoke(ctx, "/proto.DoctorService/Alive", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// DoctorServiceServer is the server API for DoctorService service.
// All implementations must embed UnimplementedDoctorServiceServer
// for forward compatibility
type DoctorServiceServer interface {
	// returns a list of doctors
	ListDoctors(context.Context, *NilMsg) (*DoctorList, error)
	// returns a list of doctors as a stream
	ListDoctorsStream(*NilMsg, DoctorService_ListDoctorsStreamServer) error
	// creates a new doctor
	AddDoctor(context.Context, *Doctor) (*Doctor, error)
	// Check to see if the service is alive
	Alive(context.Context, *NilMsg) (*NilMsg, error)
	mustEmbedUnimplementedDoctorServiceServer()
}

// UnimplementedDoctorServiceServer must be embedded to have forward compatible implementations.
type UnimplementedDoctorServiceServer struct {
}

func (UnimplementedDoctorServiceServer) ListDoctors(context.Context, *NilMsg) (*DoctorList, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListDoctors not implemented")
}
func (UnimplementedDoctorServiceServer) ListDoctorsStream(*NilMsg, DoctorService_ListDoctorsStreamServer) error {
	return status.Errorf(codes.Unimplemented, "method ListDoctorsStream not implemented")
}
func (UnimplementedDoctorServiceServer) AddDoctor(context.Context, *Doctor) (*Doctor, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AddDoctor not implemented")
}
func (UnimplementedDoctorServiceServer) Alive(context.Context, *NilMsg) (*NilMsg, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Alive not implemented")
}
func (UnimplementedDoctorServiceServer) mustEmbedUnimplementedDoctorServiceServer() {}

// UnsafeDoctorServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to DoctorServiceServer will
// result in compilation errors.
type UnsafeDoctorServiceServer interface {
	mustEmbedUnimplementedDoctorServiceServer()
}

func RegisterDoctorServiceServer(s grpc.ServiceRegistrar, srv DoctorServiceServer) {
	s.RegisterService(&_DoctorService_serviceDesc, srv)
}

func _DoctorService_ListDoctors_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(NilMsg)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DoctorServiceServer).ListDoctors(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/proto.DoctorService/ListDoctors",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DoctorServiceServer).ListDoctors(ctx, req.(*NilMsg))
	}
	return interceptor(ctx, in, info, handler)
}

func _DoctorService_ListDoctorsStream_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(NilMsg)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(DoctorServiceServer).ListDoctorsStream(m, &doctorServiceListDoctorsStreamServer{stream})
}

type DoctorService_ListDoctorsStreamServer interface {
	Send(*Doctor) error
	grpc.ServerStream
}

type doctorServiceListDoctorsStreamServer struct {
	grpc.ServerStream
}

func (x *doctorServiceListDoctorsStreamServer) Send(m *Doctor) error {
	return x.ServerStream.SendMsg(m)
}

func _DoctorService_AddDoctor_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Doctor)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DoctorServiceServer).AddDoctor(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/proto.DoctorService/AddDoctor",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DoctorServiceServer).AddDoctor(ctx, req.(*Doctor))
	}
	return interceptor(ctx, in, info, handler)
}

func _DoctorService_Alive_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(NilMsg)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DoctorServiceServer).Alive(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/proto.DoctorService/Alive",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DoctorServiceServer).Alive(ctx, req.(*NilMsg))
	}
	return interceptor(ctx, in, info, handler)
}

var _DoctorService_serviceDesc = grpc.ServiceDesc{
	ServiceName: "proto.DoctorService",
	HandlerType: (*DoctorServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "ListDoctors",
			Handler:    _DoctorService_ListDoctors_Handler,
		},
		{
			MethodName: "AddDoctor",
			Handler:    _DoctorService_AddDoctor_Handler,
		},
		{
			MethodName: "Alive",
			Handler:    _DoctorService_Alive_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "ListDoctorsStream",
			Handler:       _DoctorService_ListDoctorsStream_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "doctors.proto",
}
